package br.UFSC.GRIMA.cad;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.geom.Rectangle2D;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.URL;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;

import jsdai.lang.SdaiException;

import br.UFSC.GRIMA.bancoDeDados.AcessaBD;
import br.UFSC.GRIMA.cad.visual.JanelaCodigoSTEP_view;
import br.UFSC.GRIMA.cad.visual.JanelaFundoFrame;
import br.UFSC.GRIMA.capp.CAPP;
import br.UFSC.GRIMA.capp.CondicoesDeUsinagem;
import br.UFSC.GRIMA.entidades.ProjectManager;
import br.UFSC.GRIMA.feature.Face;
import br.UFSC.GRIMA.feature.Feature;
import br.UFSC.GRIMA.util.PrintUtilities;
import br.UFSC.GRIMA.util.projeto.Projeto;



public class JanelaPrincipal extends JanelaFundoFrame 
{
	public OrdemDeFabricacaoJDialog ordem;
	public AcessaBD bancoDeDados;
	public Projeto projeto = null;
	private Face faceVisualizada = null;
	private Face faceTrabalho = null;
	private boolean modificado = false;
	public double zoom = 1;
	/**
	 * matrizRotacoes [6(FaceDesenhada)][4(verticeAtivado)][3(tipoRotacao)][2(novaFace novoVertice)]
	 */

	 //JOptionPane optionPane;
	//public MapeadoraDeWorkingstep mapeadora;
	
	static int convert(byte bb){
		return (bb - 48);
	}
	/////////
	
	
	
	
	
	class AbrirPeloBD extends JFrame implements ActionListener
	{
		    JLabel L1;
			JButton B2,B3;
			JComboBox TA1;
			JPanel P1;
			private AcessaBD bancoDeDados;
			
			
			
			AbrirPeloBD(AcessaBD bancoDeDados,JanelaPrincipal appp)
			{
				
				this.bancoDeDados = bancoDeDados;
				setTitle("Abrir projeto pelo servidor");
				setResizable(false);
				getContentPane().setLayout (new FlowLayout());
				L1 = new JLabel("Projetos:");
				L1.setForeground(Color.black);		
				B2 = new JButton("Abrir");
				B3 = new JButton("Cancelar");		
				B2.addActionListener(this);
				B3.addActionListener(this);
				P1 = new JPanel();
				P1.setLayout (new FlowLayout());
				TA1 = new JComboBox(bancoDeDados.listaProgeto());
				TA1.setEnabled(true);
				getContentPane().add(L1);
				getContentPane().add(TA1);
				getContentPane().add(B2);
				getContentPane().add(B3);
				getContentPane().add(P1);
				setLocation(200,200);
				pack();
				
			}
			
			
			
			public void actionPerformed(ActionEvent e)
			{
				
				if (e.getSource() == B3) //cancelar
				{
				dispose();
				}
				
				if (e.getSource() == B2) //abrir
				{
					try {
						abrir1(bancoDeDados.getProjetoPorID(TA1.getSelectedIndex()));
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (ClassNotFoundException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					dispose();
					
				}
			}
			
			
		
	} 
	
	
	
	
	//////
	
	public CondicoesDeUsinagem condicoesAtuais = null;

	public JanelaPrincipal(Projeto projeto, AcessaBD bancoDeDados)	{
	
		this.bancoDeDados = bancoDeDados;
		this.projeto = projeto;
		this.buttonCriarCavidade.setEnabled(false);
		this.buttonCriarDegrau.setEnabled(false);
		this.buttonCriarRanhura.setEnabled(false);
		this.menuItemCriarCavidade.setEnabled(false);
		this.menuItemCriarDegrau.setEnabled(false);
		this.menuItemCriarRanhura.setEnabled(false);

		this.init();
	}

	public void init(){
		this.adicionarOuvidores();
		this.adjustJFrame();

		this.initComponents();

		this.setVisible(true);
	}
	
	

	
	
	
public static String write(byte[] barney) throws IOException {
		
		String lyly="",sinal="";
		for (int i = 0; i < barney.length; i++) {
			if(barney[i]<0){
				sinal="-";
				if(barney[i]==(byte)-128){
					sinal="";
				}
				barney[i]= (byte) (barney[i]*(-1));
			}
			
			else
				sinal="+";
			if(barney[i]<10 && barney[i]>-10){
				lyly=lyly+sinal+"00"+barney[i];
			}
			else if(barney[i]<100 && barney[i]>-100){
				lyly=lyly+sinal+"0"+barney[i];
			}
			else
				lyly=lyly+sinal+barney[i];
		}
		
	return lyly;	
	}
public byte[] read(String lyly){
	byte[] temp = lyly.getBytes();
	byte[] barney = new byte[temp.length/4];
	//System.out.println("" + temp.length+ temp[temp.length-1]+ temp[temp.length-2]+ temp[temp.length-3]+ temp[temp.length-4]+ temp[temp.length-5]+ temp[temp.length-6]);
	for(int i=0; i < temp.length ; i=i+4 ){
		if(temp[i]==45){
			barney[i/4]=(byte)((-1)*(convert(temp[i+1])*100 + convert(temp[i+2])*10 +convert(temp[i+3])));
		}
		else 
			barney[i/4]=(byte)(convert(temp[i+1])*100 + convert(temp[i+2])*10 +convert(temp[i+3]));
		
		
		//System.out.println("" + barney[pointIndex/4] +": "+ pointIndex/4 + ":" + convert(temp[pointIndex+1])*100 + convert(temp[pointIndex+2])*10 +convert(temp[pointIndex+3]));
	}
	return barney;
}

void abrir1(String gg) throws IOException, ClassNotFoundException{
	byte b2[];
	b2=read(gg);
	ByteArrayInputStream bait = new ByteArrayInputStream(b2);
	ObjectInputStream in =new ObjectInputStream(bait);
	this.projeto=(Projeto)in.readObject();
	in.close();
	this.faceVisualizada = (Face)this.projeto.getBloco().faces.elementAt(0);
	this.faceTrabalho = (Face)this.projeto.getBloco().faces.elementAt(0);
	this.desenhador.alterarProjeto(this.projeto);
	atualizarArvore();
}
	public void initComponents(){
		//seta a possibilidade de salvar ou n�o no banco de dados
		this.menuItemSalvarBD.setEnabled(true);
		
		//inicializa o desenhador
		this.desenhador = new DesenhadorDeFaces(this.projeto);
		this.scrollPaneDesenho.setViewportView(this.desenhador);
		this.desenhador.revalidate();
		this.scrollPaneDesenho.revalidate();

		//inicializa o local de trabalho na pe�a bruta
		this.trocarFaceTrabalho(Face.XY);
		this.trocarFaceVisualizada(Face.XY, 0);
		
		//inicializa a arvore de informa��es do projeto
		this.atualizarArvore();		
	}

	public void adjustJFrame(){
	//	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		

		Toolkit toolkit = this.getToolkit();

		this.setResizable(false);
		this.pack();

		Dimension windowDimension = toolkit.getScreenSize();
		Dimension thisDimension = this.getPreferredSize();
		this.setLocation((int)(windowDimension.getWidth() - thisDimension.getWidth())/2, (int)(windowDimension.getHeight() - thisDimension.getHeight())/2);


	}
	class PerguntaSalvarNoBD extends JFrame implements ActionListener
	{
		    JLabel L1;
			JButton B2,B3;
			JPanel P1;
			private AcessaBD bancoDeDados;
			private Projeto projeto;
			
			
			
			PerguntaSalvarNoBD(AcessaBD bancoDeDados,Projeto projeto)
			{
				this.projeto = projeto;
				this.bancoDeDados = bancoDeDados;
				setTitle("Dejesa salvar projeto antes de sair?");
				setResizable(false);
				getContentPane().setLayout (new FlowLayout());
				L1 = new JLabel("Dejesa salvar o projeto no servidor?");
				L1.setForeground(Color.black);		
				B2 = new JButton("Salvar");
				B3 = new JButton("N�o salvar");		
				B2.addActionListener(this);
				B3.addActionListener(this);
				P1 = new JPanel();
				P1.setLayout (new FlowLayout());
				
				getContentPane().add(L1);
			
				getContentPane().add(B2);
				getContentPane().add(B3);
				getContentPane().add(P1);
				setLocation(200,200);
				pack();
				
			}
			
			
			
			public void actionPerformed(ActionEvent e)
			{
				
				if (e.getSource() == B3) //nao salvar
				{
					dispose();
				}
				
				if (e.getSource() == B2) //salvar
				{
					try {
						ByteArrayOutputStream bout = new ByteArrayOutputStream();
						ObjectOutputStream out=new ObjectOutputStream(bout);
						out.writeObject(projeto);
						out.close();
						byte[] b1 = bout.toByteArray();
						String s1= write(b1);
						if(bancoDeDados.salvoNoBD(projeto)){
							bancoDeDados.updateProjeto(this.projeto, s1);
						}
						else
						    bancoDeDados.insertProjeto(this.projeto,s1);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} 
					dispose();
					
				}
			}
			
			
		
	} 
	
	
	
	public void adicionarOuvidores(){
		JanelaPrincipal_button_actionAdapter ouvidorBotao = new JanelaPrincipal_button_actionAdapter(this);

		WindowListener x = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				
				JFrame Janela2 = new PerguntaSalvarNoBD(bancoDeDados,projeto);
				WindowListener x1 = new WindowAdapter()
				{
					public void windowClosing(WindowEvent e)
					{
						dispose();
					}
				};
				Janela2.addWindowListener(x1);
				Janela2.show();
				
			}
		};
		this.addWindowListener(x);
		this.show();
		this.buttonRemover.addActionListener(ouvidorBotao);
		this.buttonCriarFuro.addActionListener(ouvidorBotao);
		this.buttonCriarDegrau.addActionListener(ouvidorBotao);
		this.buttonCriarRanhura.addActionListener(ouvidorBotao);
		this.buttonCriarCavidade.addActionListener(ouvidorBotao);
		this.buttonEditar.addActionListener(ouvidorBotao);
		this.zoomMais.addActionListener(ouvidorBotao);
		this.zoomMenos.addActionListener(ouvidorBotao);
		this.girar2.addActionListener(ouvidorBotao);
		this.girarEixoX.addActionListener(ouvidorBotao);
		this.girarEixoY.addActionListener(ouvidorBotao);

		JanelaPrincipal_menus_actionAdapter ouvidorMenus = new JanelaPrincipal_menus_actionAdapter(this,projeto,bancoDeDados);

		this.menuItemAbrirSTEP.addActionListener(ouvidorMenus);
		this.menuItemGerar.addActionListener(ouvidorMenus);
		this.menuItemAbout.addActionListener(ouvidorMenus);
		this.menuItemHelp.addActionListener(ouvidorMenus);
		this.menuItemCriarFuro.addActionListener(ouvidorMenus);
		this.menuItemCriarDegrau.addActionListener(ouvidorMenus);
		this.menuItemCriarRanhura.addActionListener(ouvidorMenus);
		this.menuItemCriarCavidade.addActionListener(ouvidorMenus);
		this.menuItemSair.addActionListener(ouvidorMenus);
		this.menuItemVerPlanosReferencia.addActionListener(ouvidorMenus);
		this.menuItemAbrir.addActionListener(ouvidorMenus);
		this.menuItemAbrirBD.addActionListener(ouvidorMenus);
		this.menuItemSalvar.addActionListener(ouvidorMenus);
		this.menuItemSalvarBD.addActionListener(ouvidorMenus);
		this.menuItemNovoProjeto.addActionListener(ouvidorMenus);
		this.menuItemOrdemFabricacao.addActionListener(ouvidorMenus);
		this.menuItemImprimir.addActionListener(ouvidorMenus);
		this.fixarFaceXY.addActionListener(ouvidorMenus);//fixar pe�a em plano XY
		this.fixarFaceYZ.addActionListener(ouvidorMenus);//fixar pe�a em plano YZ
		this.fixarFaceXZ.addActionListener(ouvidorMenus);//fixar pe�a em plano XZ
		this.fixarFaceYX.addActionListener(ouvidorMenus);//fixar pe�a em plano YX
		this.fixarFaceZY.addActionListener(ouvidorMenus);//fixar pe�a em plano ZY
		this.fixarFaceZX.addActionListener(ouvidorMenus);//fixar pe�a em plano ZX
		this.gerarCAPP.addActionListener(ouvidorMenus);
		this.vistaPlanoXY.addActionListener(ouvidorMenus);	//Vista em Plano XY
		this.vistaPlanoYZ.addActionListener(ouvidorMenus);	//Vista em Plano YZ
		this.vistaPlanoXZ.addActionListener(ouvidorMenus);	//Vista em Plano XZ
		this.vistaPlanoYX.addActionListener(ouvidorMenus);//Vista em Plano YX
		this.vistaPlanoZY.addActionListener(ouvidorMenus);//Vista em Plano ZY
		this.vistaPlanoZX.addActionListener(ouvidorMenus);//Vista em Plano ZX
		this.vistaPlanosPrincipais.addActionListener(ouvidorMenus); //Desenha todos os planos
		this.mostrarPecaBruta.addActionListener(ouvidorMenus);	//Mostra ou deleta a pe�a Bruta
		this.gerar3D.addActionListener(ouvidorMenus);			//Gera vista em 3D
		this.verEixos.addActionListener(ouvidorMenus);
		this.mostrarMesa.addActionListener(ouvidorMenus);
		this.mostrarFeaturesSecundarias.addActionListener(ouvidorMenus);
		super.textFieldZoom.addActionListener(ouvidorMenus);
		this.menuGirar.addActionListener(ouvidorMenus);

		JanelaPrincipal_combobox_actionAdapter ouvidorCombobox = new JanelaPrincipal_combobox_actionAdapter(this);
		//this.zoomComboBox.addItemListener(ouvidorCombobox);

		JanelaPrincipal_arvore_actionAdapter ouvidorArvore = new JanelaPrincipal_arvore_actionAdapter(this);
		this.tree2.addTreeSelectionListener(ouvidorArvore);
	}


	public void setModificado(boolean x){
		this.modificado = x;
	}


	/**
	 * come�o dos tratadores de cada evento
	 */
	public void girarX(){

	}

	public void girarY(){

	}

	public void girar(int botaoClicado){
		int[] novaPosicao = Matrizes.rotacoes[this.faceVisualizada.getTipo()][this.faceVisualizada.getVerticeAtivada()][botaoClicado];
		this.trocarFaceVisualizada(novaPosicao[0], novaPosicao[1]);
		this.label3.setText(faceVisualizada.getTipoString());
		this.desenhador.repaint();
		//this.vistas.setFaceCentral(novaPosicao[0], novaPosicao[1]);
	}

	public void mostrarFeaturesSecundarias(){
		if(this.desenhador.dFeaturesSecundarias)
			this.desenhador.dFeaturesSecundarias = false;
		else
			this.desenhador.dFeaturesSecundarias = true;
		this.desenhador.repaint();
	}

	public void editarFeature(){

	}

	public void removerFeature(){
		boolean ok = false;
		DefaultMutableTreeNode node1 = null, node2 = null;
		node1 = (DefaultMutableTreeNode)tree2.getLastSelectedPathComponent();
		if (node1 != null){
			node2 = (DefaultMutableTreeNode)node1.getParent();
			if(node2 != null)
				ok = true;
		}
		if (ok)
		{
			Object objPai = node1.getUserObject();
			Object objFilho = node2.getUserObject();

			String stringPai = (String)objFilho;
			String stringFilho = (String)objPai;
			Face face = this.getFace(stringPai);
			if(face != null){
				int pos = getPosicaoFeature(stringFilho, face);

				if(pos != -1)
				{
					Feature featureRemovida = (Feature)face.features.elementAt(pos);
					Rectangle2D removida2d = face.criarRetanguloShape(featureRemovida);
					Vector removidas = new Vector();
					for (int i = 0; i < face.features.size(); i++)
					{
						Feature featureTmp = (Feature)face.features.elementAt(i);
						Rectangle2D rect2dTmp = face.criarRetanguloShape(featureTmp);
						if (removida2d.contains(rect2dTmp))
						{
							removidas.add(featureTmp);
						}
					}
					//System.out.println(" removidas = " + removidas + " elementos: " + removidas.size());
					//if (removidas.size() != 0)
					if (removidas.size() > 1)
					{
						//avisa ao cara
						// remove

						int i = JOptionPane.showConfirmDialog(null, "A feature que você selecionou " +
								"remover� tamb�m todas as features que estam debaixo dela" +
								"\n                                                   quer remov�-la mesmo assim? ", 
								"Aviso de remo��o de varias features associadas", JOptionPane.OK_CANCEL_OPTION);

						if (i == 0)
						{
							for (int j = 0; j < removidas.size(); j++)
							{
								Feature fTmp = (Feature)removidas.elementAt(j);

								for (int r = 0; r < face.features.size(); r++)
								{
									Feature f = (Feature)face.features.elementAt(r);
									if (fTmp.equals(f))
									{
										face.features.removeElementAt(r);
									}
								}
							}
							this.atualizarArvore();
							this.desenhador.repaint();
							JOptionPane.showMessageDialog(null, "As features foram removidas com sucesso", "remoc�o com sucesso",JOptionPane.INFORMATION_MESSAGE);
						}
						//System.out.println("face.features: " + face.features);
					}
					if (removidas.size() == 1)
					{
						int i = JOptionPane.showConfirmDialog(this, 
								"          Voc� Clicou em remover uma br.UFSC.GRIMA.feature, " +
								"                      \n" +
								"           Tem certeza que deseja remov�-la? ",
								"Remover Feature", JOptionPane.OK_CANCEL_OPTION);
						if(i == 0){
							//System.out.println("elementos: " + face.features);
							face.features.removeElementAt(pos);
							this.desenhador.repaint();
							JOptionPane.showMessageDialog(null, 
									"A Feature que voc� selecionou foi removida com sucesso",
									"Remo��o concluida", JOptionPane.INFORMATION_MESSAGE);
							this.modificado = false;
							this.atualizarArvore();
							//System.out.println("elementos: " + face.features);
						}
					}
				}
				else{
					JOptionPane.showMessageDialog(null, 
							"O item que voc� selecionou nao pode ser removido",
							"Erro ao remover item (AXOO1)", JOptionPane.ERROR_MESSAGE);
				}				
			}
			else{
				JOptionPane.showMessageDialog(null, 
						"O item que voc� selecionou nao pode ser removido",
						"Erro ao remover item (SMDO2)", JOptionPane.ERROR_MESSAGE);
			}
		}
		else{
			JOptionPane.showMessageDialog(null, 
					"O item que voc� selecionou nao pode ser removido",
					"Erro ao remover item (LDKO3)", JOptionPane.ERROR_MESSAGE);
		}
	}

	public Face getFace(String str)	{
		int indice = -1;
		if (str.equals("Face XY"))
		{
			indice = 0;
		}
		else
			if(str.equals("Face YZ"))
			{
				indice = 1;
			}
			else
				if(str.equals("Face XZ"))
				{
					indice = 2;
				}
				else
					if(str.equals("Face YX"))
					{
						indice = 3;
					}
					else
						if(str.equals("Face ZY"))
						{
							indice = 4;
						}
						else
							if(str.equals("Face ZX"))
							{
								indice = 5;
							}

		if(indice == -1)
			return null;
		else
			return (Face)this.projeto.getBloco().faces.elementAt(indice);
	}

	/**
	 * Retorna a posi��o de uma br.UFSC.GRIMA.feature no vetor de features da face de entrada.
	 * Estado - finalizada.
	 * 
	 * @param input
	 * @param face
	 * @return
	 */
	public int getPosicaoFeature(String input, Face face){
		int nTipo = -1;
		int n = -1;

		StringTokenizer token = new StringTokenizer(input, " ");
		if (token.countTokens() == 2)
		{
			String tipo = token.nextToken();
			String num = token.nextToken();

			if(tipo.equals("Furo"))
				nTipo = 0;
			else if(tipo.equals("Degrau"))
				nTipo = 1;
			else if(tipo.equals("Ranhura"))
				nTipo = 2;
			else if(tipo.equals("Cavidade"))
				nTipo = 3;
			else{
				//dialog pane
				return -1;
			}
			try
			{
				n = Integer.parseInt(num);
			}
			catch(Exception e)
			{
				//dialog pane
				return -1;
			}
			for(int i = 0; i < face.features.size(); i++){
				Feature f = (Feature)face.features.elementAt(i);
				if(f.getTipo() == nTipo && f.getIndice() == n){
					return i;
				}
			}
		}
		else{
			return -1;
		}
		return -1;
	}

	public void atualizarArvore(){
		this.tree2 = this.projeto.getJTree();
		//this.tree2.addTreeSelectionListener(this);
		this.tree2.getSelectionModel().setSelectionMode
		(TreeSelectionModel.CONTIGUOUS_TREE_SELECTION);
		scrollPaneTree.setViewportView(tree2);
		scrollPaneTree.revalidate();
		//System.out.println("" + tree2);
		//tree2.getSelectionPath();	
	}

	public JTree getArvore(){
		return new JTree(new DefaultMutableTreeNode("Projeto"));
	}
	/**
	 * 				imprimir folha   ****
	 */
	public void imprimirTela(){
		PrintUtilities.printComponent(this.desenhador);
	}

	public void novoProjeto(){
		/*if(
		optionPane.showConfirmDialog(this, "                
		O projeto atual n�o foi Salvo,                       \n" +
				"                            Deseja salv�-lo? ",
				"Salvar Projeto Atual", JOptionPane.INFORMATION_MESSAGE) == 1)
		{

		}*/

		//JOptionPane.showConfirmDialog(this, "               
		//O projeto atual n�o foi Salvo,                       \n" +
		//	"                            Deseja salv�-lo? ",
		//"Salvar Projeto Atual", JOptionPane.INFORMATION_MESSAGE);

		//this.dispose();
		NovoProjeto novo = new NovoProjeto(this.projeto.getDadosDeProjeto().getUserID(), this.projeto.getDadosDeProjeto().getUserName());
		novo.setVisible(true);
	}

	/**
	 * Altera a face que esta sendo visualizada.****************************
	 * 
	 * @param pos
	 */
	public void trocarFaceVisualizada(int faceNova, int verticeNovo){
		this.faceVisualizada = (Face)this.projeto.getBloco().faces.elementAt(faceNova);
		this.faceVisualizada.setVertice(verticeNovo);
		//this.desenhador.setFaceDesenhada(this.faceVisualizada.getTipo());  /***********/
		this.desenhador.setFacePrincipal(this.faceVisualizada.getTipo(), verticeNovo);
	}

	public void verEixos(){
		if (this.desenhador.dEixos)
		{
			this.desenhador.dEixos = false;
		}
		else
			this.desenhador.dEixos = true;
		this.desenhador.repaint();
	}

	public void mostrarPlanosPrincipais(){
		//this.vistas.setVisible(true);
		//this.vistas.pack();
		this.desenhador.trocarModo();
		this.desenhador.repaint();
	}

	public void mostrarMesa(){
		if(this.desenhador.dMesa)
			this.desenhador.dMesa = false;
		else
			this.desenhador.dMesa = true;
		this.desenhador.repaint();
	}

	public void diminuirZoom(){
		double zoom = this.getZoom() - 0.05;
		if(zoom > 0.1)
			this.zoom = zoom;
		this.scrollPaneDesenho.revalidate();
		this.textFieldZoom.setText("" + Math.round(zoom * 100));
		this.desenhador.setZoom(zoom);
	}

	public void aumentarZoom(){
		double zoom = this.getZoom() + 0.05;
		this.scrollPaneDesenho.revalidate();
		this.textFieldZoom.setText(Math.round(zoom * 100) + "");
		desenhador.setZoom(zoom);
	}

	public void pecaBruta()	{
		if(this.desenhador.blank)
			this.desenhador.blank = false;
		else
			this.desenhador.blank = true;
		this.desenhador.repaint();
	}

	public void gerar3D(){

	}

	public void gerarCAPP()	{
		/**
		 * Tem que perguntar o tipo de material para o usuario.
		 * Caso ele escolha um material proprio, deve-se pedir as
		 * condicoes de usinagem do material.
		 * 
		 * Estes dados devem ser enviados para a classe CAPP.
		 * 
		 * Quando o usuario resolver enviar uma ordem de fabricacao,
		 * deve-se verificar se ja existem dados referentes ao material e �s
		 * condicoes, neste caso pergunta-se ao usuario se ele deseja manter
		 * estas configuracoes.
		 * Caso ele deseje alterar as configuracoes ou caso estas ainda nao existam
		 * deve-se pergunta-las ao usuario.
		 * Por fim, deve-se perguntar ao usuario a quantidade de pe�as que ele
		 * deseja.
		 * 
		 * IMPORTANTE:
		 * O codigo HPGL formatado so deve ser gerado quando o usuaro solicitar
		 * uma ordem de fabricacao, por causa do parametro quantidade.
		 */
		boolean ok = false;
		if(this.condicoesAtuais == null){
			JanelaCondicoesDeUsinagem condicoes = new JanelaCondicoesDeUsinagem(this);
			ok = true;
		}
		else{
			int i = JOptionPane.showConfirmDialog(null, "Deseja utilizar as condi��es de usinagem atuais?\n" + this.condicoesAtuais.toString());

			if(i == 0)
				ok = true;
			else if(i == 1){
				JanelaCondicoesDeUsinagem condicoes = new JanelaCondicoesDeUsinagem(this);
				ok = true;
			}
			else{
				ok = false;
			}
		}

		if(ok){
			CAPP capp = new CAPP(this.projeto, this.condicoesAtuais);
			String hpgl = capp.codigoHPGL_texto;
			JanelaCodigoHPGL janelaCodigoHPGL = new JanelaCodigoHPGL(hpgl);
		}
		//imprime*/
	}

	public void gerenciarOrdem(OrdemDeFabricacaoJDialog odfj){
		if(odfj==null){
	 odfj = new OrdemDeFabricacaoJDialog(this);
		odfj.setVisible(true);
		}
		else
			odfj.dispose();
	}
	
	public void salvar(){
		FileDialog fd = new FileDialog(this, "Salvar", FileDialog.SAVE);

		fd.setVisible(true);
		String dir = fd.getDirectory();
		String file = fd.getFile();
		String filePath = dir + file + ".GRM";
		try
		{
			ObjectOutputStream out = new ObjectOutputStream
			(new FileOutputStream(filePath, false));
			out.writeObject(this.projeto);
			out.flush();
			out.close();
			//arquivo vai estar salvo
			//this.salvo = true;//global
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public void salvarNoBD() throws IOException, ClassNotFoundException{
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		ObjectOutputStream out=new ObjectOutputStream(bout);
		out.writeObject(this.projeto);
		out.close();
		byte[] b1 = bout.toByteArray();
		String s1= write(b1);
		if(bancoDeDados.salvoNoBD(projeto)){
			bancoDeDados.updateProjeto(this.projeto, s1);
		}
		else
		    bancoDeDados.insertProjeto(this.projeto,s1);
	}

	public void abrir(){
		FileDialog fd = new FileDialog(this, "Abrir", FileDialog.LOAD);

		fd.setVisible(true);

		String dir = fd.getDirectory();
		String file = fd.getFile();
		String filePath = dir + file;
		try
		{
			ObjectInputStream in = new ObjectInputStream
			(new FileInputStream(filePath));

			this.projeto = (Projeto)(in.readObject());
			in.close();
			this.faceVisualizada = (Face)this.projeto.getBloco().faces.elementAt(0);
			this.faceTrabalho = (Face)this.projeto.getBloco().faces.elementAt(0);
			this.desenhador.alterarProjeto(this.projeto);
			this.atualizarArvore();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null,
					"                O arquivo que voc� esta tentando abrir " +
					"\n n�o corresponde ao tipo de dados suportados pelo sistema",
					"Erro ao tentar abrir o arquivo", JOptionPane.OK_CANCEL_OPTION);
		}
	}
	
	public void abrirPeloBD(){
		final JFrame Janela = new AbrirPeloBD(bancoDeDados,this);
		WindowListener x = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				Janela.dispose();
			}
		};
		Janela.addWindowListener(x);
		Janela.show();
	}
	
	/**
	 *   ********************** CRIA FEATURES *********************************
	 *
	 */

	public void criarFuro()	{
		CriarFuro cf = new CriarFuro(this, faceTrabalho);
		cf.setVisible(true);
		//System.out.println("CRIAR FURO");
		//this.vistas.desenhadorDeFaces.repaint();
	}

	public void criarDegrau(){
		CriarDegrau cd = new CriarDegrau(this, faceTrabalho);
		cd.setVisible(true);
	}

	public void criarRanhura(){
		CriarRanhura cr = new CriarRanhura(this, faceTrabalho);
		cr.setVisible(true);		
	}

	public void criarCavidade(){
		CriarCavidade cc = new CriarCavidade(this, faceTrabalho);
		cc.setVisible(true);
	}

	public void mostrarReferencia(){
		PlanosRef PR = new PlanosRef(this);
		PR.setVisible(true);
	}

	/**#########################################################################
	 *                  Altera a face de trabalho!
	 *##########################################################################
	 * @param pos
	 */
	public void trocarFaceTrabalho(int pos){
		this.faceTrabalho = (Face)this.projeto.getBloco().faces.elementAt(pos);
		switch(pos)
		{
		case 0:

			this.vistaPlanoXY.setSelected(true);
			this.vistaPlanoXY.doClick();
			this.label5.setText("XY");

			break;

		case 1:

			this.vistaPlanoYZ.setSelected(true);
			this.vistaPlanoYZ.doClick();
			this.label5.setText("YZ");

			break;

		case 2:

			this.vistaPlanoXZ.setSelected(true);
			this.vistaPlanoXZ.doClick();
			this.label5.setText("XZ");


			break;

		case 3:

			this.vistaPlanoYX.setSelected(true);
			this.vistaPlanoYX.doClick();
			this.label5.setText("YX");


			break;

		case 4:

			this.vistaPlanoZY.setSelected(true);
			this.vistaPlanoZY.doClick();
			this.label5.setText("ZY");

			break;

		case 5:

			this.vistaPlanoZX.setSelected(true);
			this.vistaPlanoZX.doClick();
			this.label5.setText("ZX");

			break;

		default:
			break;
		}
	}
	/**
	 * *************************** zoom **********************************
	 * @return
	 */
	public void itemStateChanged(ItemEvent evt) {
		int index = this.zoomComboBox.getSelectedIndex();
		desenhador.setZoom((25 + index*25)/100);
		desenhador.repaint();
	}
	public double getZoom()
	{	double zoom;
	try
	{
		zoom = Double.parseDouble(textFieldZoom.getText()) / 100;
		if (zoom > 0)
		{ return zoom;
		}
		else
		{
			JOptionPane.showMessageDialog(null,
					"Digite um N�mero inteiro positivo ",
					"Erro em campo ZOOM", JOptionPane.INFORMATION_MESSAGE);
			return -1;
		}
	}
	catch (Exception e)
	{	
		JOptionPane.showMessageDialog(null,
				"Digite um N�mero v�lido",
				"Erro no campo ZOOM", JOptionPane.INFORMATION_MESSAGE);
		return -1;
	}
	}
	/**
	 * 		**************************************************************************
	 */
	public void about() 
	{	
		
		JTextArea outputArea = new JTextArea();
		outputArea.setText("                    Aplicativo desenvolvido na\n"
				+ "      Universidade Federal de Santa Catarina\n"
				+ "          Faculdade de Engenharia Mec�nica\n"
				+ "Centro Tecnol\u00f3gico | Florian�polis - SC - Brasil\n"
				+ "GRIMA/GRUCON, Caixa Postal 476  88040-900\n"
				+ "                E-mails: jcarlos@emc.ufsc.br \n " 
				+ "                          jcf@grucon.ufsc.br");
		outputArea.setEditable(false);
		/**
		 * Instancia o �cone para ser exibido
		 */
		URL figgrima = getClass().getResource("/images/figgrima.jpg");
		ImageIcon icone = new ImageIcon(figgrima);      
		JOptionPane.showMessageDialog(null, outputArea, "About",
				JOptionPane.INFORMATION_MESSAGE, icone);
		icone.getAccessibleContext();
	}
	
	public void help(){
		try{
		Runtime.getRuntime().exec("cmd.exe /C start iexplore.exe http://www.grima.ufsc.br/~jticona/CAD/ajuda.php");
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	public void openSTEPWindow() {
		try {
			ProjectManager.getHoleProject().relationateHoleVars();
			JanelaCodigoSTEP_view novo = new JanelaCodigoSTEP_view();
			novo.editTextArea(ProjectManager.getHoleProject(), ProjectManager.getHoleProject().createSTEP21File());
			novo.setVisible(true);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	public void openSTEPFile() {
		System.out.println("Open");
		// TODO Auto-generated method stub
		
	}
}

class JanelaPrincipal_button_actionAdapter implements ActionListener
{
	JanelaPrincipal parent;
	public JanelaPrincipal_button_actionAdapter(JanelaPrincipal parent)
	{
		this.parent = parent;
	}
	public void actionPerformed(ActionEvent event) {
		Object origem = event.getSource();


		if (origem == this.parent.buttonCriarFuro) 
		{	this.parent.criarFuro();
		}
		else if (origem == this.parent.buttonCriarDegrau)
		{	this.parent.criarDegrau();
		}
		else if (origem == this.parent.buttonCriarRanhura)
		{	this.parent.criarRanhura();
		}
		else if (origem == this.parent.buttonCriarCavidade)
		{	this.parent.criarCavidade();
		}
		else if (origem == this.parent.zoomMais)
		{	this.parent.aumentarZoom();
		}
		else if (origem == this.parent.zoomMenos)
		{	this.parent.diminuirZoom();
		}
		else if (origem == this.parent.girarEixoX)
		{
			this.parent.girar(0);
		}
		else if (origem == this.parent.girarEixoY)
		{
			this.parent.girar(1);
		}
		else if (origem == this.parent.girar2)
		{
			this.parent.girar(2);
		}
		else if (origem == this.parent.buttonEditar)
		{
			this.parent.editarFeature();
		}
		else if (origem == this.parent.buttonRemover)
		{	
			this.parent.removerFeature();
		}
	}
}
class JanelaPrincipal_menus_actionAdapter implements ActionListener
{
	class PerguntaSalvarNoBD extends JFrame implements ActionListener
	{
		    JLabel L1;
			JButton B2,B3;
			JPanel P1;
			private AcessaBD bancoDeDados;
			private Projeto projeto;
			
			
			
			PerguntaSalvarNoBD(AcessaBD bancoDeDados,Projeto projeto)
			{
				this.projeto = projeto;
				this.bancoDeDados = bancoDeDados;
				setTitle("Dejesa salvar projeto antes de sair?");
				setResizable(false);
				getContentPane().setLayout (new FlowLayout());
				L1 = new JLabel("Dejesa salvar o projeto no servidor?");
				L1.setForeground(Color.black);		
				B2 = new JButton("Salvar");
				B3 = new JButton("N�o salvar");		
				B2.addActionListener(this);
				B3.addActionListener(this);
				P1 = new JPanel();
				P1.setLayout (new FlowLayout());
				
				getContentPane().add(L1);
			
				getContentPane().add(B2);
				getContentPane().add(B3);
				getContentPane().add(P1);
				setLocation(200,200);
				pack();
				
			}
			
			
			
			public void actionPerformed(ActionEvent e)
			{
				
				if (e.getSource() == B3) //nao salvar
				{
					parent.dispose();
					dispose();
				}
				
				if (e.getSource() == B2) //salvar
				{
					try {
						ByteArrayOutputStream bout = new ByteArrayOutputStream();
						ObjectOutputStream out=new ObjectOutputStream(bout);
						out.writeObject(projeto);
						out.close();
						byte[] b1 = bout.toByteArray();
						String s1= write(b1);
						if(bancoDeDados.salvoNoBD(projeto)){
							bancoDeDados.updateProjeto(this.projeto, s1);
						}
						else
						    bancoDeDados.insertProjeto(this.projeto,s1);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} 
					parent.dispose();
					dispose();
					
				}
			}
			
			
		
	} 
	
	
	public static String write(byte[] barney) throws IOException {
		
		String lyly="",sinal="";
		for (int i = 0; i < barney.length; i++) {
			if(barney[i]<0){
				sinal="-";
				if(barney[i]==(byte)-128){
					sinal="";
				}
				barney[i]= (byte) (barney[i]*(-1));
			}
			
			else
				sinal="+";
			if(barney[i]<10 && barney[i]>-10){
				lyly=lyly+sinal+"00"+barney[i];
			}
			else if(barney[i]<100 && barney[i]>-100){
				lyly=lyly+sinal+"0"+barney[i];
			}
			else
				lyly=lyly+sinal+barney[i];
		}
		
	return lyly;	
	}
	private JanelaPrincipal parent;
	private Projeto projeto;
	private AcessaBD bancoDeDados;
	
	public JanelaPrincipal_menus_actionAdapter(JanelaPrincipal parent,Projeto projeto,AcessaBD bancoDeDados)
	{
		this.parent = parent;
		this.projeto = projeto;
		this.bancoDeDados = bancoDeDados;
	}
	public void actionPerformed(ActionEvent event)
	{
		Object origem = event.getSource();
		if(origem == this.parent.menuItemAbout)
		{	this.parent.about();
		}
		else if(origem == this.parent.menuItemHelp){
			this.parent.help();
		}
		else if(origem == this.parent.menuItemAbrirSTEP){
			this.parent.openSTEPFile();
		}
		else if(origem == this.parent.menuItemGerar){
			this.parent.openSTEPWindow();
		}
		else if (origem == this.parent.menuItemCriarFuro)
		{	this.parent.criarFuro();
		}
		else if (origem == this.parent.menuItemCriarDegrau)
		{	this.parent.criarDegrau();
		}
		else if (origem == this.parent.menuItemCriarRanhura)
		{	this.parent.criarRanhura();
		}
		else if (origem == this.parent.menuItemCriarCavidade)
		{	this.parent.criarCavidade();
		}
		else if (origem == this.parent.menuItemSair)
		{	
			//deseja salvar?
			JFrame Janela1 = new PerguntaSalvarNoBD(bancoDeDados,projeto);
			WindowListener x2 = new WindowAdapter()
			{
				public void windowClosing(WindowEvent e)
				{
					try {
						ProjectManager.getHoleProject().closeSession();
					} catch (SdaiException e1) {
						e1.printStackTrace();
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
					}
					parent.dispose();
				}
			};
			Janela1.addWindowListener(x2);
			Janela1.show();
			
			
			
			
		}
		else if (origem == this.parent.menuItemVerPlanosReferencia)
		{	this.parent.mostrarReferencia();
		}
		else if(origem == this.parent.menuItemAbrir){
			this.parent.abrir();
		}
		else if(origem == this.parent.menuItemAbrirBD){
			this.parent.abrirPeloBD();
		}
		else if (origem == this.parent.fixarFaceXY)
		{	
			this.parent.trocarFaceTrabalho(Face.XY);
		}
		else if (origem == this.parent.fixarFaceYZ)
		{	
			if (this.parent.projeto.getBloco().getComprimento() <= 
				this.parent.projeto.getMaquina().profundidade)
			{
				this.parent.trocarFaceTrabalho(/*1*/Face.YZ);
			}
			else
			{ 
				JOptionPane.showMessageDialog(null, "        " +
						"N�o pode criar Features nessa face " +
						"\n pois ultrapassa a altura maxima da m�quina" + 
						"\n     se deseja poder� apenas visualiz�-la", "Mensagem", 
						JOptionPane.CANCEL_OPTION);
			}		
		}
		else if (origem == this.parent.fixarFaceXZ)
		{	if(this.parent.projeto.getBloco().getLargura() <= 
			this.parent.projeto.getMaquina().profundidade)
		{
			this.parent.trocarFaceTrabalho(/*2*/Face.XZ);
		}
		else
		{
			JOptionPane.showMessageDialog(null, "        " +
					"N�o pode criar Features nessa face " +
					"\n pois ultrapassa a altura maxima da m�quina" + 
					"\n    se deseja poder� apenas visualiz�-la", "Mensagem", 
					JOptionPane.OK_CANCEL_OPTION);
		}
		}
		else if (origem == this.parent.fixarFaceYX)
			if (this.parent.projeto.getBloco().getProfundidade() <= 
				this.parent.projeto.getMaquina().getProfundidade())
			{
				this.parent.trocarFaceTrabalho(/*3*/Face.YX);
			}
			else
			{
				JOptionPane.showMessageDialog(null, "        " +
						"N�o pode criar Features nessa face " +
						"\n pois ultrapassa a altura maxima da m�quina" + 
						"\n    se deseja poder� apenas visualiz�-la", "Mensagem", 
						JOptionPane.OK_CANCEL_OPTION);
			}
		else if (origem == this.parent.fixarFaceZY)
			if (this.parent.projeto.getBloco().getComprimento() <= 
				this.parent.projeto.getMaquina().getProfundidade())
			{
				this.parent.trocarFaceTrabalho(/*4*/Face.ZY);
			}
			else
			{	
				JOptionPane.showMessageDialog(null, "        " +
						"N�o pode criar Features nessa face " +
						"\n pois ultrapassa a altura maxima da m�quina" + 
						"\n      se deseja poder� apenas visualiz�-la", "Mensagem", 
						JOptionPane.OK_CANCEL_OPTION);
			}	
		else if (origem == this.parent.fixarFaceZX)
			if (this.parent.projeto.getBloco().getLargura() <= 
				this.parent.projeto.getMaquina().getProfundidade())
			{	
				this.parent.trocarFaceTrabalho(/*5*/Face.ZX);
			}
			else
			{
				JOptionPane.showMessageDialog(null, "        " +
						"N�o pode criar Features nessa face " +
						"\n pois ultrapassa a altura maxima da m�quina" + 
						"\n     se deseja poder� apenas visualiz�-la", "Mensagem", 
						JOptionPane.OK_CANCEL_OPTION);
			}
		else if (origem == this.parent.menuItemSalvar)
		{	this.parent.salvar();
		}
		else if (origem == this.parent.menuItemSalvarBD)
		{	try {
			this.parent.salvarNoBD();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		}
		else if (origem == this.parent.menuItemOrdemFabricacao)
		{	
			this.parent.gerenciarOrdem(null);
		}
		else if (origem == this.parent.gerarCAPP)
		{	
			this.parent.gerarCAPP();
		}
		else if (origem == this.parent.gerar3D)
		{	this.parent.gerar3D();
		}
		else if (origem == this.parent.vistaPlanoXY)
		{	this.parent.trocarFaceVisualizada(0, 0);
		this.parent.label3.setText("XY");
		}
		else if (origem == this.parent.vistaPlanoYZ)
		{	this.parent.trocarFaceVisualizada(1, 0);
		this.parent.label3.setText("YZ");
		}
		else if (origem == this.parent.vistaPlanoXZ)
		{	this.parent.trocarFaceVisualizada(2, 0);
		this.parent.label3.setText("XZ");
		}
		else if (origem == this.parent.vistaPlanoYX)
		{	this.parent.trocarFaceVisualizada(3, 0);
		this.parent.label3.setText("YX");
		}
		else if (origem == this.parent.vistaPlanoZY)
		{	this.parent.trocarFaceVisualizada(4, 0);
		this.parent.label3.setText("ZY");
		}
		else if (origem == this.parent.vistaPlanoZX)
		{	this.parent.trocarFaceVisualizada(5, 0);
		this.parent.label3.setText("ZX");
		}
		else if(origem == this.parent.mostrarPecaBruta)
		{	this.parent.pecaBruta();
		}
		else if (origem == this.parent.verEixos)
		{	this.parent.verEixos();
		}
		else if (origem == this.parent.vistaPlanosPrincipais)
		{	this.parent.mostrarPlanosPrincipais();
		}
		else if (origem == this.parent.mostrarMesa)
		{	this.parent.mostrarMesa();
		}
		else if (origem == this.parent.textFieldZoom)
		{
			double zoom = this.parent.getZoom();
			if (zoom != - 1)
				this.parent.desenhador.setZoom((double)zoom);
			this.parent.scrollPaneDesenho.revalidate();
		}
		else if (origem == this.parent.menuGirar || origem == this.parent.girar2) 
		{
			this.parent.girar(2);
		}
		else if (origem == this.parent.menuItemNovoProjeto)
		{
			this.parent.novoProjeto();
		}
		else if (origem == this.parent.menuItemImprimir)
		{
			this.parent.imprimirTela();	
		}
		else if (origem == this.parent.mostrarFeaturesSecundarias)
		{
			this.parent.mostrarFeaturesSecundarias();
		}
	}
}
class JanelaPrincipal_combobox_actionAdapter implements ItemListener
{
	JanelaPrincipal parent;

	public JanelaPrincipal_combobox_actionAdapter(JanelaPrincipal parent)
	{
		this.parent = parent;
	}
	public void itemStateChanged(ItemEvent event)
	{
	}
}
class JanelaPrincipal_arvore_actionAdapter implements TreeSelectionListener
{
	JanelaPrincipal parent;

	public JanelaPrincipal_arvore_actionAdapter(JanelaPrincipal parent)
	{
		this.parent = parent;
	}
	public void valueChanged(TreeSelectionEvent event)
	{
	}
}
 

