package br.UFSC.GRIMA.simulator;

//File:  animation/bb/SimulationPanel.java
//Description: Panel to layout buttons and graphics area.
//Author: Fred Swartz
//Date:   February 2005

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import jsdai.lang.A_double;
import jsdai.lang.SdaiException;

import br.UFSC.GRIMA.cad.visual.SimulationFrame;
import br.UFSC.GRIMA.util.Util;

/////////////////////////////////////////////////////////////////// SimulationPanel
public class SimulationPanel extends SimulationFrame implements ActionListener {
 ToolPanel tPanel;   // The bouncing ball panel
 Rectangle r;
 ArrayList<Point> arrayListPoints;
 //========================================================== constructor
 /** Creates a panel with the controls and bouncing ball display. */
 
 public SimulationPanel(Rectangle r, ArrayList<A_double> arrayListPoints) {
     //... Create components
     this.r = r;
     try {
		this.arrayListPoints = Util.ajustDoubleArray(arrayListPoints);
	} catch (SdaiException e) {
		e.printStackTrace();
	}
	 
	 JButton startButton = this.iniciar;        
     JButton stopButton  = this.pausar;
     JButton reiniciateButton = this.reiniciar;
     JSlider slider = this.slider;
     
     
     tPanel = new ToolPanel(r,this.arrayListPoints);
     tPanel.setBounds(new Rectangle(510,510));
     toolPanel.setBounds(new Rectangle(510,510));
     this.toolPanel.add(tPanel);  
     this.setResizable(false);
     
     //... Add Listeners
     startButton.addActionListener(new StartAction());
     stopButton.addActionListener(new StopAction());
     slider.addChangeListener(new SlideAction());
     reiniciateButton.addActionListener(this);
 }//end constructor
 
 public SimulationPanel(Rectangle r, ArrayList<Point> arrayListPoints, Boolean b) {
     //... Create components
     this.r = r;
     this.arrayListPoints = arrayListPoints;
	 
	 JButton startButton = this.iniciar;        
     JButton stopButton  = this.pausar;
     JButton reiniciateButton = this.reiniciar;
     JSlider slider = this.slider;
     
     
     tPanel = new ToolPanel(r,arrayListPoints);
     tPanel.setBounds(new Rectangle(510,510));
     toolPanel.setBounds(new Rectangle(510,510));
     this.toolPanel.add(tPanel);  
     this.setResizable(false);
     
     //... Add Listeners
     startButton.addActionListener(new StartAction());
     stopButton.addActionListener(new StopAction());
     slider.addChangeListener(new SlideAction());
     reiniciateButton.addActionListener(this);
 }//end constructor
 
 public void actionPerformed(ActionEvent e) {
	 toolPanel.removeAll();
	 tPanel = new ToolPanel(r,arrayListPoints);
     tPanel.setBounds(new Rectangle(510,510));
     toolPanel.setBounds(new Rectangle(510,510));
     this.toolPanel.add(tPanel);  
     this.setResizable(false);
     tPanel.repaint();
 }
 
 ////////////////////////////////////// inner listener class StartAction
 class SlideAction implements ChangeListener {
     public void actionPerformed(ActionEvent e) {
        
     }

	public void stateChanged(ChangeEvent arg0) {
		tPanel.setVelocity(slider.getValue());
		
	}
 }
 
 class StartAction implements ActionListener {
     public void actionPerformed(ActionEvent e) {
         tPanel.setAnimation(true);
     }
 }
 
 class StopAction implements ActionListener {
     public void actionPerformed(ActionEvent e) {
         tPanel.setAnimation(false);
     }
 }
}//endclass SimulationPanel
