package br.UFSC.GRIMA.acceptance;

import static org.junit.Assert.*;

import java.awt.Point;
import java.awt.Rectangle;
import java.util.ArrayList;

import jsdai.lang.ASdaiModel;
import jsdai.lang.A_double;
import jsdai.lang.SdaiException;
import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class STEP_NCReaderTest {

	public Util util = new Util();
	public ASdaiModel model;
	public STEP_NCReader reader;

	@Before
	public void setUp() {
		try {
			model = util.openFile21(Util.getUserPath()
					+ "test\\res\\STEP-NC 2HolesFile.p21");
			reader = new STEP_NCReader(model);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getPiecePropsTest() {
		Rectangle rectangle = reader.getPieceProps();
		Assert.assertEquals(200.0, rectangle.getWidth());
		Assert.assertEquals(150.0, rectangle.getHeight());
	}

	@Test
	public void getPointsTest() {
		ArrayList<A_double> arrayListPoints = null;
		try {
			arrayListPoints = reader.getPoints();
			A_double p1 = arrayListPoints.get(0);
			A_double p2 = arrayListPoints.get(1);
			Assert.assertEquals(30.0, p1.getByIndex(1));
			Assert.assertEquals(20.0, p1.getByIndex(2));
			Assert.assertEquals(50.0, p2.getByIndex(1));
			Assert.assertEquals(40.0, p2.getByIndex(2));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}
}
