package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.EBlock;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class BlockReaderTest {

	Util util = new Util();
	ProjectReader projectReader;
	WorkpieceReader workpieceReader;
	BlockReader blockReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EProject eProject = projectReader.getProject();
			EWorkpiece eWorkpiece = projectReader.getWorkpiece();
			workpieceReader = new WorkpieceReader(eWorkpiece);
			EBlock eBlock = (EBlock) workpieceReader.getBounding_Geometry();
			blockReader = new BlockReader(eBlock);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getNameTest() {
		try {
			String blockName = blockReader.getName();
			Assert.assertTrue(blockName.equals("Block"));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getPositionTest() {
		try {
			EAxis2_placement_3d blockPosition = blockReader.getPosition();
			Assert.assertNotNull(blockPosition);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getXTest() {
		try {
			
			Assert.assertTrue(blockReader.getX() == 110.0);
			
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getYTest() {
		try {
			double Y = blockReader.getY();
			Assert.assertNotNull(Y);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getZTest() {
		try {
			double Z = blockReader.getZ();
			Assert.assertNotNull(Z);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
}
