package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;

import java.util.ArrayList;

import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.ACartesian_point;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.AManufacturing_feature;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.ECartesian_point;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.A_double;
import jsdai.lang.A_string;
import jsdai.lang.SdaiException;
import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class CartesianPointReaderTest {
	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;
	MachiningWorkingStepReader workingStepReader;
	AExecutable aMachiningWorkingstep;
	APlane aPlane;
	PlaneReader planeReader;
	AAxis2_placement_3d aAxis2Placement_3d;
	Axis2Placement_3dReader aAxis2Placement_3dReader ;
	Cartesian_pointReader cartesianPointReader ;
	AManufacturing_feature aManufacturingFeature;
	Round_holeReader roundHoleReader;
	
	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
			aMachiningWorkingstep = workplanReader.getMachiningWorkingSteps();
			workingStepReader = new MachiningWorkingStepReader(aMachiningWorkingstep);
			aManufacturingFeature = workingStepReader.getItsFeature();
			roundHoleReader = new Round_holeReader(aManufacturingFeature);
			aAxis2Placement_3d = roundHoleReader.getFeaturePlacement();
			aAxis2Placement_3dReader = new Axis2Placement_3dReader(aAxis2Placement_3d);
			ACartesian_point aCartesianPoint = aAxis2Placement_3dReader.getCartesianPoint();
			cartesianPointReader = new Cartesian_pointReader(aCartesianPoint);
			
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getPositionTest() {
		ArrayList<A_double> position = cartesianPointReader.getPosition();
		
		try {
			Assert.assertEquals(50.0, position.get(0).getByIndex(1));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
		
	@Test
	public void getNameTest() {
		String name;
		try {
			name = cartesianPointReader.getName().get(0);
			Assert.assertEquals("", name);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
}