package br.UFSC.GRIMA.Entity;

import java.util.ArrayList;

import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.AMachining_operation;
import jsdai.SMachining_schema.AManufacturing_feature;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EMachining_operation;
import jsdai.SMachining_schema.EMachining_workingstep;
import jsdai.SMachining_schema.EManufacturing_feature;
import jsdai.SMachining_schema.EPlane;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class MachiningWorkingStepReader {

	private AExecutable aMachiningWorkingstep;

	public MachiningWorkingStepReader(AExecutable aMachiningWorkingstep) {
		this.aMachiningWorkingstep = aMachiningWorkingstep;
	}

	public APlane getAPlanes() {
		APlane aPlane = new APlane();

		try {
			SdaiIterator iterator = aMachiningWorkingstep.createIterator();
			int i = 1;
			while (iterator.next()) {

				EMachining_workingstep eMachining_workingstep = (EMachining_workingstep) aMachiningWorkingstep
						.getCurrentMember(iterator);
				aPlane.addByIndex(i, (EPlane) eMachining_workingstep
						.getIts_secplane(null));
				i++;
			}

		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return aPlane;

	}

	public AManufacturing_feature getItsFeature() {
		AManufacturing_feature aManufacturingFeature = new AManufacturing_feature();
		try {
			SdaiIterator iterator = aMachiningWorkingstep.createIterator();
			int i = 1;
			while (iterator.next()) {

				EMachining_workingstep eMachining_workingstep = (EMachining_workingstep) aMachiningWorkingstep
						.getCurrentMember(iterator);
				aManufacturingFeature.addByIndex(i,
						(EManufacturing_feature) eMachining_workingstep
								.getIts_feature(null));
				i++;
			}

		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return aManufacturingFeature;
	}

	public AMachining_operation getItsMachiningOperation() {
		AMachining_operation aMachiningOperation = new AMachining_operation();
		try {
			SdaiIterator iterator = aMachiningWorkingstep.createIterator();
			int i = 1;
			while (iterator.next()) {

				EMachining_workingstep eMachining_workingstep = (EMachining_workingstep) aMachiningWorkingstep
						.getCurrentMember(iterator);
				aMachiningOperation.addByIndex(i,
						(EMachining_operation) eMachining_workingstep
								.getIts_operation(null));
				i++;
			}
		} catch (SdaiException e) {

		}

		return aMachiningOperation;
	}

	public ArrayList<String> getItsId() {
		ArrayList<String> aItsId = new ArrayList<String>();
		SdaiIterator iterator;
		try {
			iterator = aMachiningWorkingstep.createIterator();
			while (iterator.next()) {

				EMachining_workingstep eMachiningWorkingstep = (EMachining_workingstep) aMachiningWorkingstep
						.getCurrentMember(iterator);
				aItsId.add((String) eMachiningWorkingstep.getIts_id(null));
			}
		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return aItsId;
	}
}
