package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;
import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class PlaneReaderTest {
	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;
	MachiningWorkingStepReader workingStepReader;
	AExecutable aMachiningWorkingstep;
	APlane aPlane;
	PlaneReader planeReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
			aMachiningWorkingstep = workplanReader.getMachiningWorkingSteps();
			workingStepReader = new MachiningWorkingStepReader(aMachiningWorkingstep);
			aPlane = workingStepReader.getAPlanes();
			planeReader = new PlaneReader(aPlane);

		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getPlanesTest() {
		AAxis2_placement_3d aAxis2Placement_3d = planeReader.getAAxis2_Placement_3d();
		try {
			Assert.assertTrue(((EAxis2_placement_3d) aAxis2Placement_3d
					.getByIndex(1)).getName(null).equals(""));
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}

	}
}
