package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class ProjectReaderTest {
	Util util = new Util();
	ProjectReader projectReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getProjectTest() {
		try {
			EProject eProject = projectReader.getProject();
			Assert.assertNotNull(eProject);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}

	@Test
	public void getWorkplanTest() {
		try {
			EProject eProject = projectReader.getProject();
			EWorkplan eWorkplan = projectReader.getWorkplan();
			Assert.assertNotNull(eWorkplan);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}

	}

	@Test
	public void getWorkpieceTeste() {
		try {
			EProject eProject = projectReader.getProject();
			EWorkpiece eWorkpiece = projectReader.getWorkpiece();
			Assert.assertNotNull(eWorkpiece);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}

	}

}
