package br.UFSC.GRIMA.Entity;

import static org.junit.Assert.fail;
import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.AExecutable;
import jsdai.SMachining_schema.AManufacturing_feature;
import jsdai.SMachining_schema.ARound_hole;
import jsdai.SMachining_schema.AToleranced_length_measure;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.ERound_hole;
import jsdai.SMachining_schema.EToleranced_length_measure;
import jsdai.SMachining_schema.EWorkplan;
import jsdai.lang.SdaiException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import br.UFSC.GRIMA.STEPmanager.Util;

public class Round_holeReaderTest {

	Util util = new Util();
	ProjectReader projectReader;
	WorkplanReader workplanReader;
	MachiningWorkingStepReader workingStepReader;
	AExecutable aMachiningWorkingstep;
	Round_holeReader round_holeReader;

	@Before
	public void startObjects() {
		try {
			projectReader = new ProjectReader(util.openFile21(Util
					.getUserPath()
					+ "test\\res\\STEP-NC File.p21"));
			EWorkplan eWorkplan = projectReader.getWorkplan();
			workplanReader = new WorkplanReader(eWorkplan);
			aMachiningWorkingstep = workplanReader.getMachiningWorkingSteps();
			workingStepReader = new MachiningWorkingStepReader(
					aMachiningWorkingstep);
			AManufacturing_feature aManufacturingFeature = workingStepReader
					.getItsFeature();
			round_holeReader = new Round_holeReader(aManufacturingFeature);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void getDiameterTest() {
		try {
			AToleranced_length_measure featureDiameter = round_holeReader.getDiameter();
			Assert.assertNotNull(featureDiameter);
		} catch (SdaiException e) {
			e.printStackTrace();
			fail();
		}
	}
	
	@Test
	public void getFeaturePlacementTest(){
		try {
			AAxis2_placement_3d featurePlacement = round_holeReader.getFeaturePlacement();
			Assert.assertNotNull(featurePlacement);
		} catch (Exception e) {
			e.printStackTrace();
			fail();
		}
	}
    
	@After
	public void closeProject() {
		try {
			util.closeProject();
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

}
