package br.UFSC.GRIMA.Entity;

import java.lang.reflect.Array;

import jsdai.SMachining_schema.AProperty_parameter;
import jsdai.SMachining_schema.AWorkpiece;
import jsdai.SMachining_schema.CBlock;
import jsdai.SMachining_schema.CDescriptive_parameter;
import jsdai.SMachining_schema.CNumeric_parameter;
import jsdai.SMachining_schema.CRight_circular_cylinder;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.EBlock;
import jsdai.SMachining_schema.EDescriptive_parameter;
import jsdai.SMachining_schema.EMaterial;
import jsdai.SMachining_schema.ENumeric_parameter;
import jsdai.SMachining_schema.EPlacement;
import jsdai.SMachining_schema.EProject;
import jsdai.SMachining_schema.EProperty_parameter;
import jsdai.SMachining_schema.ERight_circular_cylinder;
import jsdai.SMachining_schema.EWorkpiece;
import jsdai.lang.EEntity;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class WorkpieceReader {

	ProjectReader projectReader;
	String workpieceName;
	EProject eProject;
	EWorkpiece eWorkpiece;
	EMaterial eMaterial;
	EProperty_parameter ePropertyParameter;
	String property_paremeterAux;
	Double workpieceGlobal_tolerance;
	EEntity bounding_geometry;
	EPlacement workpiecePosition;
	
	public WorkpieceReader(EWorkpiece workpiece) {
		eWorkpiece = workpiece;
	}
	
	public String getName() throws SdaiException {
		workpieceName = eWorkpiece.getIts_id(null);
		return workpieceName;
	}
	public EMaterial getMaterial()
			throws SdaiException {
		if (eWorkpiece.testIts_material(null)) {
			eMaterial = eWorkpiece.getIts_material(null);
		}
		return eMaterial;
	}
	public Double getGlobal_Tolerance()
	throws SdaiException {
		if (eWorkpiece.testGlobal_tolerance(null)) {
			workpieceGlobal_tolerance =eWorkpiece.getGlobal_tolerance(null);
		}
		return workpieceGlobal_tolerance;
	}	
	public EEntity getBounding_Geometry()
	throws SdaiException {
		if (eWorkpiece.testIts_bounding_geometry(null)) {
			bounding_geometry = eWorkpiece.getIts_bounding_geometry(null);
		}
		return bounding_geometry;
	}
	/*public String getWorkpieceMaterialStd_identifier(EProject project)
			throws SdaiException {
		String materialStd_identifier = getWorkpieceMaterial(project)
				.getStandard_identifier(null);
		return materialStd_identifier;
	}

	public String getWorkpieceMaterialIdentifier(EProject project)
			throws SdaiException {
		String materialIdentifier = getWorkpieceMaterial(project)
				.getMaterial_identifier(null);
		return materialIdentifier;
	}

	public EProperty_parameter getWorkpieceMaterial_Eproperty(EProject project)
			throws SdaiException {

		AProperty_parameter aPropertyParameter = getWorkpieceMaterial(project)
				.getMaterial_property(null);
		SdaiIterator propertyParameterIterator = aPropertyParameter
				.createIterator();
		while (propertyParameterIterator.next()) {
			ePropertyParameter = aPropertyParameter
					.getCurrentMember(propertyParameterIterator);
		}
		return ePropertyParameter;
	}

	public String getWorkpieceMaterial_Property(EProject project)
			throws SdaiException {

		EProperty_parameter property_parameter = getWorkpieceMaterial_Eproperty(project);

		if (property_parameter.isKindOf(CNumeric_parameter.class)) {
			ENumeric_parameter numeric_parameter = (ENumeric_parameter) property_parameter;
			property_paremeterAux = (numeric_parameter
					.getIts_parameter_value(null) + numeric_parameter
					.getIts_parameter_unit(null));

		}

		else if (property_parameter.isKindOf(CDescriptive_parameter.class)) {
			EDescriptive_parameter descritive_parameter = (EDescriptive_parameter) property_parameter;
			property_paremeterAux = descritive_parameter
					.getDescriptive_string(null);

		}

		return property_paremeterAux;
	}

	public EPlacement getWorkpiecePosition(
			EEntity workpieceBoundingGeometry) throws SdaiException {
		if(workpieceBoundingGeometry.isKindOf(CBlock.class)){
			EBlock block = (EBlock) workpieceBoundingGeometry;
			workpiecePosition = block.getPosition(null);
			//fazer para cilindro e para advanced_brep_shape_representation
		}
		else if(workpieceBoundingGeometry.isKindOf(CRight_circular_cylinder.class)){
			ERight_circular_cylinder circularCylinder = (ERight_circular_cylinder) workpieceBoundingGeometry;
			workpiecePosition = circularCylinder.getPosition(null);
		}
		return workpiecePosition;
	}

	public double[] getWorkpieceSize(EEntity eEntity) throws SdaiException {
		 double[] size = null;
		if(eEntity.isKindOf(CBlock.class)){
			EBlock block = (EBlock) eEntity;
			size = new double[3];
			size[0] = block.getX(null);
			size[1] = block.getY(null);
			size[2] = block.getZ(null);
		}
		if(eEntity.isKindOf(CRight_circular_cylinder.class)){
			ERight_circular_cylinder circularCylinder = (ERight_circular_cylinder) eEntity;
			size = new double[2];
			size[0] = circularCylinder.getHeight(null);
			size[1] = circularCylinder.getRadius(null);
		}
		
		return size;
	}
	*/
}

	
